//+------------------------------------------------------------------+
//|                                                       eugenk.mq4 |
//|                                                         |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright " "
#property link      ""
#property show_inputs

//,     
//    \expert\FileSeek

extern string Filename="planimetry.tpl"; //  

//,   
extern int N=100;      // 
extern int Min=2;      // 
extern int Max=100;    //E  ( Step  0,    )
extern int Step=0;     // 0,       in  Max, N .   0,    Min   Step
extern color Color=0;  //  (R=G=B=0),  .   

// 
extern string Name="Moving Average"; // 
extern int Type=0;                   //  (. "  ")
extern int Shift=0;                  //
extern int Price=4;                  //  (. " ")

//       ,   .

int rainbow[10000];  //  
int nRainbow;        //  

int GetRGB(int r, int g, int b)
{//    r, g, b
   return (256*(256*b + g) + r);
}

int BuildRainbow()
{// ,   
//      :)
   int r=255, g=0, b=0;
   int n=0;
   
   while(g !=255)
   {
      rainbow[n]=GetRGB(r, g, b);
      g++; n++;
   }   
   while(r !=0)
   {
      rainbow[n]=GetRGB(r, g, b);
      r--; n++;
   }
   while(b !=255)
   {
      rainbow[n]=GetRGB(r, g, b);
      b++; n++;
   }
   while(g !=0)
   {
      rainbow[n]=GetRGB(r, g, b);
      g--; n++;
   }
   while(r !=255)
   {
      rainbow[n]=GetRGB(r, g, b);
      r++; n++;
   }
   return (n);   
}

int GetRainbowColor(int c)
{//    
   double k=nRainbow/N;
   int n=c*k;
   return (rainbow[n]);
}

void PlaceMA(int f, int p, int c)
{//   f   MA   p   c
   string s;
   s="<indicator>";       FileWrite(f, s);       
   s="name="+Name;      FileWrite(f, s);
   s="period="+p;       FileWrite(f, s);
   s="color="+c;        FileWrite(f, s);      
   s="apply="+Price;    FileWrite(f, s);   
   s="shift="+Shift;    FileWrite(f, s);
   s="method="+Type;    FileWrite(f, s);
   s="style=0";         FileWrite(f, s);
   s="weigth=1";        FileWrite(f, s);
   s="period_flags=0";  FileWrite(f, s);
   s="show_data=1";     FileWrite(f, s);
   s="</indicator>";    FileWrite(f, s);
}

void PlaceYourOwn(int f, int p, int c)
{//      
   string s;
   s="<indicator>";       FileWrite(f, s);       
   s="name="+Name;      FileWrite(f, s);
   s="period="+p;       FileWrite(f, s);
   s="color="+c;        FileWrite(f, s);      
   s="apply="+Price;    FileWrite(f, s);   
   s="style=0";         FileWrite(f, s);
   s="weigth=1";        FileWrite(f, s);
   s="period_flags=0";  FileWrite(f, s);
   s="show_data=1";     FileWrite(f, s);   
   //    
   s="</indicator>";    FileWrite(f, s);   
}

int start()
{
   int c;      //
   int p;      //
   int f;      //
   double s;   // 
   
   s=(Max-Min); s/=N;
   nRainbow=BuildRainbow();
   if(Step!=0) s=Step;
   f=FileOpen(Filename, FILE_WRITE);
   Print("s=",s);
   
   FileWrite(f, "<chart>");
   FileWrite(f, "<window>");
   
   for(int i=0; i<N; i++)
   {
      p=Min+s*i;
      if(Color==0) c=GetRainbowColor(i); else c=Color;
      if(Name=="Moving Average") PlaceMA(f,p,c); 
      else PlaceYourOwn(f,p,c);
   }
   
   FileWrite(f,"<indicator>");
   FileWrite(f,"name=main");
   FileWrite(f,"</indicator>");  
   FileWrite(f, "</window>");   
   FileWrite(f, "</chart>");
   FileClose(f);   
   return(0);
}

